From 0000000000000000000000000000000000000000 Mon Sep 17 00:00:00 2001
From: TheKit <thekit@disroot.org>
Date: Fri, 10 Jan 2025 15:49:51 +0300
Subject: [PATCH] gprs: default IMS type APN to "ims" during context creation

---
 ofono/src/gprs.c | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

Index: ofono/ofono/src/gprs.c
===================================================================
--- ofono.orig/ofono/src/gprs.c
+++ ofono/ofono/src/gprs.c
@@ -2938,6 +2938,17 @@ static void configure_remaining_contexts
 					OFONO_GPRS_CONTEXT_TYPE_INTERNET)) {
 		add_context(gprs, NULL, OFONO_GPRS_CONTEXT_TYPE_INTERNET);
 	}
+
+	/* Make sure IMS context has non-NULL APN */
+	for (l = gprs->contexts; l; l = l->next) {
+		struct pri_context *ctx = l->data;
+
+		if (ctx->type == OFONO_GPRS_CONTEXT_TYPE_IMS &&
+			strlen(ctx->context.apn) == 0) {
+			strcpy(ctx->context.apn, gprs_context_type_to_string(
+						OFONO_GPRS_CONTEXT_TYPE_IMS));
+		}
+	}
 }
 
 static void remove_non_active_context(struct ofono_gprs *gprs,
